package com.lzmispt.data.resource.service.datasync.impl.handle;

package .tmp;

import com.lzmispt.data.resource.entity.vo.datasync.DataSyncDirVO;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

public class DirectoryTreeSearcherHandler {
  public static List<DataSyncDirVO> buildDirectoryTree(List<DataSyncDirVO> directories) {
    Map<Long, DataSyncDirVO> directoryMap = new HashMap<>();
    for (DataSyncDirVO directory : directories)
      directoryMap.put(directory.getId(), directory); 
    List<DataSyncDirVO> result = new ArrayList<>();
    for (DataSyncDirVO directory : directories) {
      Long parentId = directory.getParentId();
      if (parentId == null) {
        result.add(directory);
        continue;
      } 
      DataSyncDirVO parent = directoryMap.get(parentId);
      if (parent != null) {
        parent.setIsLeaf(Boolean.valueOf(true));
        parent.getChildrenDataSyncDir().add(directory);
      } 
    } 
    return result;
  }
  
  public static boolean containsIgnoreCase(CharSequence str, CharSequence testStr) {
    if (null == str)
      return (null == testStr); 
    return str.toString().toLowerCase().contains(testStr.toString().toLowerCase());
  }
  
  public static List<DataSyncDirVO> searchDirectoryTree(List<DataSyncDirVO> directories, String keyword) {
    List<DataSyncDirVO> result = new ArrayList<>();
    if (directories != null && !directories.isEmpty())
      for (DataSyncDirVO directory : directories) {
        if (isDirectoryMatch(directory, keyword)) {
          result.add(directory);
          searchSubDirectories(directory.getChildrenDataSyncDir(), keyword, result);
        } 
      }  
    return result;
  }
  
  private static void searchSubDirectories(List<DataSyncDirVO> directories, String keyword, List<DataSyncDirVO> result) {
    if (directories != null && !directories.isEmpty())
      for (DataSyncDirVO directory : directories) {
        if (isDirectoryMatch(directory, keyword))
          result.add(directory); 
        searchSubDirectories(directory.getChildrenDataSyncDir(), keyword, result);
      }  
  }
  
  private static boolean isDirectoryMatch(DataSyncDirVO directory, String keyword) {
    return directory.getName().contains(keyword);
  }
  
  public static String handleLikeSql(String param) {
    Objects.requireNonNull(param);
    String result = param.trim().replace("\\", "\\\\").replace("_", "\\_").replace("%", "\\%");
    return result;
  }
}
